program ListyDwukierunkowe;

{Implementacja podstawowych operacji na listach dwukierunkowych}
{Materiay do wykadu z Technik Programowania na ZSI}
{Autor: Janusz Jabonowski}
{2004}

type
  TypDanych = string; {W listach bdziemy przechowywa napisy}

  TLista2     = ^TEltListy2; {Typ listy dwukierunkowej}
  TEltListy2 = record
                        dane  : TypDanych;
                        nast  : TLista2;
                        poprz : TLista2;
                      end;

procedure Ini(var l: TLista2);
 {Inicjalizuje list na pust}
 begin
  l := nil;
 end; {Ini}

procedure WstawNaPocz(var l: TLista2; dane: TypDanych);
 {Wstawia element na pocztek listy}
 var
  pom: TLista2;
 begin
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane  := dane;
  pom^.nast  := l;
  pom^.poprz := nil;
  {Doczam je na pocztek listy}
  if l <> nil
  then
    l^.poprz := pom;
  l := pom;
 end; {WstawNaPocz}

procedure WczytajListeOdwrotnie(var l:TLista2);
 {Wczytuje list element po elemencie od uytkownika. Uwaga:}
 {odwraca kolejno elementw.}
 var
  napis: TypDanych;
 begin
  {Na pocztku lista jest pusta}
  ini(l);
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaPocz(l, napis)
  until napis = '';
 end; {WczytajListOdwrotnie}

procedure PrzejdzListe(l: TLista2);
 {Przechodzi ca list.}
 {Zwrmy uwag, el jest modyfikowane w treci tej procedury, ale nie powoduje to }
 {utraty dowizania do pocztku listy, bo l jest przekazywane przez wartos.}
 begin
  while l <> nil do
   begin
    Writeln(l^.dane);  {Tu robi co z elementem listy}
    l := l^.nast;           {A tu przechodz do nastpnego elementu}
   end;
 end; {PrzejdList}

function DlugoscListy(l: TLista2): Integer;
 {Oblicza dugo listy l}
 var
  wyn: Integer;
 begin
  wyn := 0;
  while l <> nil do
   begin
    l := l^.nast;
    wyn := wyn + 1;
   end;
  DlugoscListy := wyn
 end; {DlugoListy}

procedure UsunWszystkoZListy(var l: TLista2);
 {Usuwa wszystkie elementy z listy}
 var
  pom: TLista2; {Pomocnicza, do usuwania elementw listy}
 begin
  while l <> nil do
   begin
    pom := l;
    l := l^.nast;
    dispose(pom);
    {l^.poprz ma teraz z warto, ale nie bd ju z niej korzysta}
   end;
  l := nil;
 end; {UsuWszystkoZListy}

procedure WstawNaKoniec(var l: TLista2; dane: TypDanych);
 {Dostawia element na koniec listy. UWAGA: ta procedura jest pokazana zwn}
 {ilustracje operacji na licie, NIE jest to natomiast efektywna realizacja}
 {wstawiania na koniec listy.}
 var
  pom: TLista2;
  Poprz, Biez: TLista2; {Poprzedni i biecy element na licie}
 begin
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane := dane;
  pom^.nast := nil;
  pom^.poprz := nil; {Na razie}
  {Szukam koca listy}
  Poprz := nil;
  Biez := l;
  while Biez <> nil do
   begin
    Poprz := Biez;
    Biez := Biez^.nast;
   end;
  {Doczam stworzone pudeko na koniec listy, sprawdzajc, czy lista nie bya pusta}
  if Poprz = nil
  then
   {Lista bya pusta, wic teraz zawiera tylko to nowe pudeko}
   l := pom
  else
   {Lista nie bya pusta, wic dostawiam nowe pudeko za ostatnim elementem}
   begin
    Poprz^.nast := pom;
    pom^.poprz  := Poprz;
   end
 end; {WstawNaKoniec}

procedure WczytajListePoKolei(var l:TLista2);
 {Wczytuje list element po elemencie od uytkownika. Zachowuje kolejno}
 {wczytanych elementw.}
 var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
  ini(l);
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      WstawNaKoniec(l, napis)
  until napis = '';
 end; {WczytajListPoKolei}

procedure UsunPierwszy(var l: TLista2);
 {Usuwa pierwszy element listy l. Jeli bya pusta to nic nie robi.}
 var
  pom: TLista2; {Pomocniczy, do usuwania elementu z pamici}
 begin
  if l <> nil
  then
   begin
    pom := l;
    l := l^.nast;
    if l <> nil
    then
     l^.poprz := nil;
    dispose(pom);
   end;
 end; {UsuPierwszy}

function Szukaj(l: TLista2; Co: TypDanych): Integer;
 {Szuka liczby Co na licie l. Jeli Co wystpuje na licie daje}
 {jako wynik pozycj pierwszego wystapienia Co na licie, wpp. daje 0.}
 var
  wyn: Integer;  {W Delphi mona by uy zmiennej Result}
  Jest: Boolean; {Czy znalazem}
  Biez: Integer; {Bieca pozycja na licie}
 begin
  Wyn := 0; {Pesymistycznie}
  Jest := false;
  Biez := 1;
  while (l <> nil) and not Jest do
   if l^.dane = Co
   then
    begin
     Jest := true;
     wyn := Biez;
    end
   else
    begin
     Biez := Biez + 1;
     l := l^.nast;
   end;
  Szukaj := Wyn;
 end; {Szukaj}

 procedure UsunWskazany(var l: TLista2; Wskazany: TypDanych);
  {Usuwa wszystkie wystpienia elementu Wskazany z listy l.}
  var
   {Zwrmy uwag, e nie wystpuje tu zmienna Poprz}
   Biez: TLista2;  {Poprzedni i biecy element na licie}
   pom: TLista2;   {Pomocnicza, do usuwania elementu z listy}
  begin
   Biez := l;
   while Biez <> nil do
    begin
     if Biez^.dane = Wskazany
     then
      begin
       {Usuwam element Biez}
       pom := Biez;
       if Biez^.Poprz <> nil
       then {Usuwam kolejny (tj. nie pierwszy) element listy}
         begin
          Biez^.poprz^.nast := Biez^.nast;
          if Biez^.nast <> nil
          then
           Biez^.nast^.poprz := Biez^.poprz;
         end
       else {Usuwam pierwszy element listy}
         begin
          l := Biez^.nast;
          if l <> nil
          then
           l^.poprz := nil
         end;
       Biez := Biez^.nast; {Zwrmy uwag, e nie mona zamieni kolejnoci}
       dispose(pom);       {tych dwu instrukcji!}
      end
     else {Id dalej}
       Biez := Biez^.nast;
    end
  end; {UsuWskazany}

begin {program gwny}
 { ... }
end.

